package net.wanji.opt.service;

import com.alibaba.fastjson.JSONObject;
import net.wanji.common.framework.exception.DubboProviderException;
import net.wanji.databus.bo.CrossIdBO;
import net.wanji.databus.vo.GreenwaveListVO;
import net.wanji.opt.bo.CrossIdAndIsFirstBO;
import net.wanji.opt.bo.CrossIdAndTimeSpanBO;
import net.wanji.opt.bo.GreenwaveDetailBO;
import net.wanji.opt.bo.GreenwaveIdAndTimeStampBO;
import net.wanji.opt.bo.GreenwaveIdBO;
import net.wanji.opt.bo.SaveGreenwaveStrategyBO;
import net.wanji.opt.dto.trend.AbnormalCrossListDTO;
import net.wanji.opt.dto.trend.GreenwaveListDTO;
import net.wanji.opt.entity.EventAlarmInfo;
import net.wanji.opt.po.base.EventStatisticPo;
import net.wanji.opt.po.trend.AnalysisRidTurnIndicators;
import net.wanji.opt.po.trend.HoloEventInfoPO;
import net.wanji.opt.vo.AbnormalCrossDetailVO;
import net.wanji.opt.vo.AbnormalCrossVO;
import net.wanji.opt.vo.CommonCrossIdDateTimeVO;
import net.wanji.opt.vo.CommonCrossIdVO;
import net.wanji.opt.vo.CountRealTimeVO;
import net.wanji.opt.vo.CrossStatusTimeRateVO;
import net.wanji.opt.vo.EventAlarmVO;
import net.wanji.opt.vo.GreenStatusTimeRateVO;
import net.wanji.opt.vo.GreenWaveCrossMonitorVO;
import net.wanji.opt.vo.GreenwaveCrossMetricsVO;
import net.wanji.opt.vo.GreenwaveDetailVO;
import net.wanji.opt.vo.GreenwaveRunMonitorVO;
import net.wanji.opt.vo.GreenwaveStats;
import net.wanji.opt.vo.HoloEventVO;
import net.wanji.opt.vo.HotspotCrossLaneVO;
import net.wanji.opt.vo.HotspotCrossTurnVO;
import net.wanji.opt.vo.HotspotCrossVO;
import net.wanji.opt.vo.LaneIdAliasNameVO;
import net.wanji.opt.vo.LanePeriodTurnVO;
import net.wanji.opt.vo.LaneSnapshotIndexVO;
import net.wanji.opt.vo.OptTypeVO;
import net.wanji.opt.vo.OverflowEvent;
import net.wanji.opt.vo.TableQueryVO;
import net.wanji.opt.vo.Top5IndexVO;

import javax.servlet.http.HttpServletResponse;
import java.text.ParseException;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 事件接口
 */
public interface EventService {

    /**
     * 查询路口事件统计数
     * @param crossId
     * @param type
     * @param startTime
     * @param endTime
     * @return
     */
    EventStatisticPo findCrossEventCount(String crossId, String type, String startTime, String endTime) throws DubboProviderException;

    /**
     * 场景分布
     * @param crossId
     * @param startTime
     * @param endTime
     * @return
     */
    List<Map<String,Object>> findEventDistribute(String crossId,  String startTime, String endTime) throws DubboProviderException;

    /**
     * 当时事件报警数据监测
     * @param greenId
     * @param crossId
     * @param type 为1时查询当天最近30条，为空时查询当天所有
     * @return
     * @throws DubboProviderException
     */
    List<EventAlarmInfo> findEventAlarmInfo(String realtimeType,String eventType,String name) throws DubboProviderException;
}
